Subject: comp.lang.tcl Frequently Asked Questions (May 28, 1999) (3/5)
From: [email-masked] (Larry W. Virden)
Newsgroups: comp.lang.tcl.announce,comp.lang.tcl,comp.lang.perl.tk,comp.answers,news.answers

Archive-name: tcl-faq/part3
Posting-Frequency: monthly
Last-modified: May 28, 1999
Version: 8.117
URL: http://www.purl.org/NET/Tcl-FAQ/part3.html
Comp-lang-tcl-archive-name: tcl-faq.part03

	For more information concerning Tcl (see "part1"),
(see "part2"), (see "part4") or (see "part5").

Index of questions:

XI. Where can I get these packages?
	A. Tcl and Tk
	B. The Tcl/Tk User Contributions Archive
	C. Expect available via e-mail.
	D. EMACS and other editor modes for Tcl
	E. The tk toolbox project (obsolete)
	F. [tv]grind definitions for tcl/tk/expect
	G. BNF style notation for Tcl
	H. Tcl/Tk Quick Reference Guides
	I. Hilit 19 Tcl mode
	J. HTML versions of Tcl man pages and FAQ.
	K. Japanese translation of Tk 3.6 manuals
	L. Latex styles for the Tcl/Tk Workshop 94.
	M. Tcl References for various platforms
	N. The "How do I speed up a Tcl/Tk application" doc
	O. http files without a WWW client
	P. The patch and gzip commands, along with other useful utilities
	Q. Source code from published books
	R. Documentation relating to Perl's Tk interface
	S. Tutorials on various subjects

End of FAQ Index

----------------------------------------------------------------------

------------------------------

From: FAQ Tcl/Tk Package Catalog
Subject: -XI- Where can I get these packages?

Tcl and Extended Tcl have been posted to comp.sources.misc in the past,
appearing In volume 25 and then Tcl appeared again in volume 26 and can
be found at most comp.sources.misc archive sites in the tcl and tclx
directories.  These are quite old versions actually, but are still usable.

A few of the sites which either mirror the Tcl/Tk submissions or have special
versions are:

<URL: ftp://ftp.scriptics.com/pub/tcl/> - official home of Tcl/Tk base code
<URL: ftp://ftp.neosoft.com/languages/tcl/> - official home for comp.lang.tcl
					contributed sources archive
<URL: ftp://ftp.mirror.neosoft.com/pub/tcl/mirror/ftp.smli.com/> shadow of
					Sun's source directories.

<URL: ftp://ftp.syd.dit.csiro.au/pub/tk/> - shadow of the user contrib and base

<URL: ftp://iskut.ucs.ubc.ca/pub/X11/tcl/>

<URL: ftp://ftp.switch.ch/mirror/tcl/>

<URL: ftp://ftp.cs.tu-berlin.de/pub/tcl/> - Does not seem to be answering
<URL: ftp://ftp.Germany.EU.net/pub/programming/tools/tcl/>
<URL: ftp://ftp.hrz.uni-kassel.de/pub/tcl/> - base software
<URL: ftp://ftp.informatik.tu-muenchen.de/pub/comp/programming/languages/tcl/>
<URL: ftp://ftp.mpi-sb.mpg.de/pub/tcl/>
<URL: ftp://ftp.tu-bs.de/pub/languages/tcl/>
<URL: ftp://ftp.uni-paderborn.de/unix/tcl/>

<URL: ftp://ftp.funet.fi/pub/languages/tcl/> - user software archive

<URL: ftp://ftp.ibp.fr/pub/tcl/> - shadow of base,user,expect,ak,tkwin
	and comp.lang.tcl archive
<URL: ftp://ftp.jussieu.fr/pub/tcl/>

<URL: ftp://ftphost.comp.vuw.ac.nz/> - VUW

<URL: ftp://ftp.sra.co.jp/pub/lang/tcl/>
<URL: ftp://oskgate0.mei.co.jp/free/X/toolkits/tcl/> - shadow of ftp.cs only

<URL: ftp://ftp.ncc.up.pt/pub/tcl/code/> - some code mirrored

<URL: ftp://ftp.luth.se/pub/languages/tcl/> - some code mirrored
<URL: ftp://ftp.sunet.se/pub/lang/tcl/> - some code mirrored

<URL: http://src.doc.ic.ac.uk/packages/tcl/>
<URL: ftp://src.doc.ic.ac.uk/packages/tcl/tcl-archive/> - shadow of user archive
<URL: ftp://src.doc.ic.ac.uk/usenet/news.answers/comp.lang.tcl/> - shadow of
	FAQs
<URL: ftp://unix.hensa.ac.uk/pub/yggdrasil/usr/lib/xf-2.3/>

<URL: ftp://ftp.neosoft.com/languages/tcl/mirror/ftp.smli.com/> Mirror of scriptics.com
<URL: ftp://ftp.cs.columbia.edu/pub/archives/tcl/> - shadow of user, etc.
<URL: ftp://ftp.neosoft.com/languages/tcl/tclx-distrib/> - original home of TclX
<URL: ftp://ftp.sterling.com/programming/languages/tcl/>
<URL: ftp://ftp.uu.net/languages/tcl/> - shadow of base code only
<URL: ftp://gatekeeper.dec.com/pub/UCB/tcl/sprite/> - shadow of base only
<URL: ftp://sunsite.unc.edu/pub/Linux/> - contains port of extended Tcl and
					extended Tk to this OS.
<URL: ftp://sunsite.unc.edu/pub/languages/tcl/>
<URL: ftp://ftp.rge.com/pub/languages/tcl/>
<URL: ftp://wuarchive.wustl.edu/languages/tcl/>

Note also that there are a number of CD-ROMs now available with a snapshot
of various Tcl archive sites on them.  (See "bibliography/part1")
for details.

Another site which is available is <URL: http://ftpsearch.ntnu.no/> .
Once you enter this site, just type the name of the package you are wanting
and you should get back a list of ftp sites where the package is
available.

------------------------------

From: -XI- Where can I get these packages?
Subject: -A- Tcl and Tk

<URL: ftp://ftp.scriptics.com/pub/tcl/README> contains a description of all
the files available for ftp from <URL: ftp://ftp.scriptics.com/pub/tcl/>.

Be sure to retrieve files in image mode (type "type image" to FTP)
in order to make sure that you don't lose bits.

Most of these files are compressed tar files;  to get back the
original directory hierarchies, type a command like the following for
each file you retrieved:
		zcat tk8.0.tar.Z | tar xf -
This will create a directory named tk8.0 with all the source files and
documentation for that release.  For files with ".gz" extensions, use
a command like the following instead of the one above:
		gunzip -c tk8.0.tar.gz | tar xf -

Each of the releases has a README file in the top-level directory that
describes how to compile the release, where to find documentation, etc.

In addition to the information here, there are many other Tcl/Tk extensions,
scripts, and applications in the Tcl contributed archive, which is
currently located in the public FTP directory
<URL: ftp://ftp.neosoft.com/languages/tcl/>.

There is also a collection of Web pages on Tcl and Tk at the URL
<URL: http://www.scriptics.com/>.

Questions or problems with any of these distributions should be directed
to the <URL: news:comp.lang.tcl> newsgroup.

------------------------------

From: -XI- Where can I get these packages?
Subject: -B- The Tcl/Tk User Contributions Archive

Contributions to the Tcl/Tk Contrib Archive are most welcome --
please upload them to:

	<URL: ftp://ftp.neosoft.com/languages/tcl/incoming/>

send the archive maintainer <URL: mailto:[email-masked]> a
note stating the names of the files you uploaded and a brief description
for the index.  Otherwise, you must upload a README.filename along with
your upload.  Otherwise, your contribution probably won't get into the
archives.

Users without FTP capability should use one of the following mail-based
FTP services (send mail to the appropriate address with "help" in the
body):

BITNET users:	BITFTP <URL: mailto:[email-masked]>
Others:		<URL: mailto:[email-masked]> (DEC ftpmail)
Europe:		<URL: mailto:[email-masked]>
		<URL: mailto:[email-masked]>

*WARNING*!  The archive maintainer will *NOT* be automatically archiving
anything posted to comp.lang.tcl or previously to the mailing list.
So if you want your nifty porting instructions for getting Tcl up on your
Seiko wrist watch or your pen computer to be saved for others benefit,
be sure to ftp them into the archive.

All submissions should be ftp'ed into the above subdirectory.  Please
send <URL: mailto:[email-masked]> and a short mail message stating
the filename(s) of your contribution and a brief description (for the
Index).  If you've posted some code to comp.lang.tcl or the Tcl mailing
list, and you want it to be archived at this site, please deposit it in
<URL: ftp://ftp.neosoft.com/languages/tcl/incoming/> or mail it in a suitable form
(preferably uuencoded compressed tar file, but a shar file's OK) to
<URL: mailto:[email-masked]>.
Also, PLEASE include a {packagename}.README file which describes the
contribution.

The Tcl/Tk archive can also be accessed via the World Wide Web (WWW)
with the URL, <URL: http://www.neosoft.com/tcl/>.  Check out this
interface, which provides you the ability to register software, upload
packages via the WWW browser, updated searching functions and more.

Note: I have noticed that some authors prefer to use plain names rather than
version level type names.  This means that you should a) make note of when
you get a package, and b) check the archive occasionally to see if a newer
version of the package has appeared.

------------------------------

From: -XI- Where can I get these packages?
Subject: -C- Expect available via e-mail.

Besides being available via <URL: ftp://ftp.cme.nist.gov/pub/expect/>,
expect can also be received by email by sending the message
"send pub/expect/expect.shar.Z" to <URL: mailto:[email-masked]> .

------------------------------

From: -XI- Where can I get these packages?
Subject: -D- EMACS modes for Tcl

<URL: mailto:[email-masked]> (Sean Levy) has hacked a version of Emacs's
C mode into a tcl-mode.el.  He mentions that you must use semi-colons at the
end of each statement to get indentation to work right, but he found that
easier than doing without.

The code is on <URL: ftp://ftp.cs.cmu.edu/afs/cs/user/snl/pub/tcl-mode.el.z>
(don't forget binary mode) as well as
<URL: ftp://ftp.neosoft.com/languages/tcl/alcatel/distrib/tcl-mode.el.Z>.

<URL: mailto:[email-masked]> (Julian Anderson) was also working
on an Emacs Tcl minor mode to fundamental.

<URL: mailto:[email-masked]> (Tom Tromey) has contributed a tcl.el
which is better than his former tcl-help.el.  This is a modified version of
Chris Lindblad's Tcl editing mode.  This new editing mode contains the
help code, a tcl interaction mode, menus, font lock support, etc.  It
is available on the Emacs Lisp Archive at
<URL: ftp://archive.cis.ohio-state.edu/pub/emacs/elisp-archive/modes/tcl.el.Z>
<URL: http://drip.colorado.edu/%7Etromey/src/tcl.el>,
and on
<URL: ftp://ftp.neosoft.com/languages/tcl/alcatel/extensions/tcl.el.gz>

<URL: mailto:[email-masked]> (Gregor Schmid) has written
a major mode for tcl scripts.  He posted tcl-mode 1.1 to gnu.emacs.sources
in March and it should be on the Ohio State emacs elisp-archive - but I was
not able to locate it.

The latest version of xemacs (formerly lemacs) mentions that it has
a tcl-mode built in.  Use (add-hook 'tcl-mode-hook 'turn-on-font-lock)
to turn on color highliting.

Donal K. Fellows <URL: mailto:[email-masked]> has an extra elisp
library at <URL: http://www.cs.man.ac.uk/%7Efellowsd/tcl/> which
provides enhanced highlighting.

Lars Magne Ingebrigtsen <URL: mailto:[email-masked]> has written Expect
functionality in an elisp package.   It is going to be included in Emacs
in a future release.  Email the contact about details.

David Schweikert <URL: mailto:[email-masked]> has written a tcl/tk
mode for JED.  You can download it at:
<URL: http://www.ee.ethz.ch/%7Edwschwei/jed/tclmode.sl>.

------------------------------

From: -XI- Where can I get these packages?
Subject: -E- The tk toolbox project (obsolete)

The Tk Toolbox & Toolchest project.

The Toolchest consisted of convenience routines for Tcl and Tk - a kind of a
ibc for Tcl.  The toolchest was a collection of commonly used code and
some specialized code such as file selectors, dialogs that take care of
keyboard traversal through items automatically, etc.

Unfortunately, the development effort has currently come to a stop on this
project and it is not yet known when it will be started again.

There was, at one point in the past, a mailing list for discussion of
the tk toolbox, kindly provided by Ari Lemmke.  To subscribe, one wrote a
message with the line:

X-Mn-Admin: join tktools

in the body or header of the message, and sent this message to
<URL: mailto:[email-masked]> .

Then to write to the list, messages were sent to
<URL: mailto:[email-masked]> with the line
X-Mn-Key: TKTOOLS
added to the header or the body of the message.  One especially had to remember
this step when replying to messages from the list.

For more info about the list server (mailnet), one sent
an empty message to <URL: mailto:[email-masked]> .

Intermediate snapshots were announced on this mailing list.

If you had problems or were willing to donate code or whatever,
you could contact the code maintainer (one of the three main implementors)
at <URL: mailto:[email-masked]> or <URL: mailto:[email-masked]> .

------------------------------

From: -XI- Where can I get these packages?
Subject: -F- [tv]grind definitions for tcl/tk/expect

<URL: mailto:[email-masked]> (Martin Hamilton) has come up with
a preliminary grindcap definition for Tcl, Tk and expect.  These are available
as <URL: ftp://ftp.neosoft.com/languages/tcl/sorted/packages-7.6/print/vgrind.defs>.

<URL: mailto:[email-masked]> (Andy Rabagliati) has come up with a preliminary
grindcap definition for Tcl.  Contact him for more details.

------------------------------

From: -XI- Where can I get these packages?
Subject: -G- BNF style notation for Tcl

<URL: mailto:[email-masked]> (TERRENCE MONROE BRANNON) in July of 1993,
posted some yacc code for a tcl-to-c parser.  This, along with Adam Sah's Tcl
compiler, are a couple of sources with which folk could start.

------------------------------

From: -XI- Where can I get these packages?
Subject: -H- Tcl/Tk Quick Reference Guides

Paul E Raines (<URL: mailto:[email-masked]> has writen some
quick reference guides for Tcl.  You may find the web page for them
at <URL: http://www.slac.stanford.edu/%7Eraines/tkref.html>.
He has versions for Tcl 7.4, 7.5, and 8.0.  If you go to the
Neosoft site
<URL: ftp://ftp.neosoft.com/languages/tcl/sorted/packages-7.6/info/ref/>
I believe you will also find a version of the file there.

The tar files contain the TeX and PostScript versions of a 3 column listing
of all widget methods and options and summaries of the wm, winfo, pack,
place and bind commands.

This material is based on work done by
Jeff Tranter <URL: mailto:[email-masked]> to code up quick reference
information in TeX.

Ron Patterson has created a TealInfo-based Palm Pilot Quick Reference guide
<URL: http://www.palmgear.com/software/showsoftware.cfm?prodID=2532 >
which requires the shareware TealInfo application from
<URL: http://www.tealpoint.com/> .

------------------------------

From: -XI- Where can I get these packages?
Subject: -I- Hilit 19 Tcl mode

AI. Aaron Roydhouse <URL: mailto:[email-masked]> wrote, and
<URL: mailto:[email-masked]> (Julian Anderson) posted,
the following:

(hilit-set-mode-patterns
 'tcl-mode
 '(("\\s #.*$" nil comment)
   ("^#.*$" nil comment)
   ("\"[^\\\"]*\\(\\\\\\(.\\|\n\\)[^\\\"]*\\)*\"" nil string)
   ("\\$[-_a-zA-Z]+" nil varref)
   ("^source.*$" nil include)
   ("\\b\\(global\\|upvar\\)\\b" nil decl)
   ("\\b\\(error\\|debug\\)\\b" nil decl)
   ("^\\s *proc\\s +\\(\\w\\|[_']\\)+" nil defun)
   ("\\b\\(set\\|lset\\|list\\|if\\|case\\|while\\|switch\\|then\\|else\\|
for\\|foreach\\|return\\|expr\\|catch\\)\\b" nil keyword)))

Dwight Shih <URL: mailto:[email-masked]> later posted the following font
lock mode:

(defvar tcl-font-lock-keywords
  (list
   (list (concat "\\b\\("
                 (mapconcat 'identity
                            '("set" "lset" "list" "if" "case" "while"
                              "switch" "then" "else" "for" "foreach"
                              "return" "expr" "catch" "puts" "proc"
                              "trace")
                            "\\|")
                 "\\)\\b")
         1 'font-lock-keyword-face t)
   (list (concat "\\b\\("
                 (mapconcat 'identity
                            '("global" "upvar" "uplevel" "error" "debug")
                            "\\|")
                 "\\)\\b")
         1 'font-lock-type-face t)
   (list "^\\s *proc\\s +\\(\\(\\w\\|[_']\\)+\\)" 1 'font-lock-function-name-fac
e t))
  "keywords for tcl-mode")

(defun font-lock-set-defaults ()
  "Set `font-lock-keywords' to something appropriate for this mode."
  (setq font-lock-keywords
        (cond ((eq major-mode 'lisp-mode)       lisp-font-lock-keywords)
              ((eq major-mode 'emacs-lisp-mode) lisp-font-lock-keywords)
              ((eq major-mode 'c-mode)          c-font-lock-keywords)
              ((eq major-mode 'c++-c-mode)      c-font-lock-keywords)
              ((eq major-mode 'c++-mode)        c++-font-lock-keywords)
              ((eq major-mode 'tex-mode)        tex-font-lock-keywords)
              ((eq major-mode 'perl-mode)       perl-font-lock-keywords)
              ((eq major-mode 'tcl-mode)        tcl-font-lock-keywords)
              ((eq major-mode 'texinfo-mode)    texi-font-lock-keywords)
              (t nil))))

------------------------------

From: -XI- Where can I get these packages?
Subject: -J- HTML versions of Tcl man pages and FAQ.

Mike Hopkirk <URL: mailto:[email-masked]> has provided a tar archive of
HyperText Markup Language (HTML) versions of the comp.lang.tcl FAQ, the
Tcl/Tk man pages, index pages for the man pages, and a top level access
page to tie together all the above.  It is
<URL: ftp://ftp.neosoft.com/languages/tcl/sorted/packages-7.6/info/tclhtml.tar.z>

Note that once these have been untarred, one can use a WorldWideWeb (WWW)
browser such as Mosaic, Lynx, etc. to begin at the Tcl.html page and read
the entire distribution.  The original source of this package can be
examined at:
<URL: http://www.sco.com/Technology/tcl/Tcl.html>

Having the package in this way provides a means for those behind a firewall
to examine the docs frozen at this point in time.  There are no commitments
to continue providing updates to this package.

The man pages provided here were made using a Perl script called
man2html originally written by <URL: mailto:[email-masked]> (Brooks Cutter)
and slightly post processed.

Tom Phelps <URL: mailto:[email-masked]> has written a program
which allows one to translate formatted man pages into many formats,
including HTML.  (See "part4") for details on RosettaMan/PolyglotMan.

Tom L. Davis <URL: mailto:[email-masked]> has provided HTML versions
of the Tcl 7.6/Tk 4.2 man pages at
<URL: ftp://ftp.neosoft.com/languages/tcl/sorted/packages-7.6/info/man/Tcl-Tk_docs_v2.html.tar.gz>.  These
pages use HTML tables and forms.
<URL: ftp://ftp.neosoft.com/languages/tcl/sorted/packages-7.6/info/man/Tcl-Tk_docs_8.0a1.html.tar.gz>
covers the alpha 1 release of Tcl 8.0/Tk 8.0.

There is a frame based version of the Tcl/Tk man pages at
<URL: http://www.tcltk.com/TclTkMan/TclTkManPages.html>.
Also at the same site is a keyword cross reference.  See it at
<URL: http://www.sco.com/Technology/tcl/man-7.6-4.2/xref/xref.html>.

An official home for the man pages for Tcl 7.5/Tk 4.1, Tcl 7.6/Tk 4.2
and Tcl 8.0/Tk 8.0 can be found at <URL: http://www.scriptics.com/man/> or
<URL: http://www.scriptics.com/resource/doc/manual/>.
For instance, at <URL: http://www.scriptics.com/man/tcl8.1/contents.htm>
is Tcl 8.1 man pages.  These are also available at
<URL: http://www.elf.org/tcl8.0.tar.gz>.
<URL: http://www.gnt.net/~n5ial/Tcl/new-contents.tar.gz> is a set of indexes
for the man pages.

Chris Nelson <URL: mailto:[email-masked]> is revising Tcl man pages
to be clearer and more helpful.  He is working on getting his pages
up at <URL: http://usai.asiainfo.com:8080/people/markh/tcl/manpages/>.

Another set of Tcl documentation is available at
<URL: http://gardiner.ucolick.org:80/opt/tcl/tclX8.0.4/tcl/help/tcl/>.

A set of the Tcl/Tk 8.0 man pages translated to Russian is avaiable at
the following pages:
Ms Windows <URL: http://www.florin.ru/win/tcl-tk/I_gu10.htm>
KOI-8 <URL: ttp://www.florin.ru/koi/tcl-tk/I_gu10.htm>
IBM 866, Alternative h<URL: ttp://www.florin.ru/alt/tcl-tk/I_gu10.htm>
ISO <URL: ttp://www.florin.ru/iso/tcl-tk/I_gu10.htm>

------------------------------

From: -XI- Where can I get these packages?
Subject: -K- Japanese translation of Tk 3.6 manuals

Toshiya Kitayama <URL: mailto:[email-masked]> and [email-masked] have made
a Japanese translation of Tk 3.6 manual pages except pack-old.n available
at <URL: ftp://ftp.sra.co.jp/pub/lang/tcl/jp/tk3.6jp.man.tar.gz>.  If
you have questions or comments, send them to <URL: mailto:[email-masked]>.

------------------------------

From: -XI- Where can I get these packages?
Subject: -L- Latex styles for the Tcl/Tk Workshop 94.

Yasuro Kawata <URL: mailto:[email-masked]> released the
Latex styles as well as a sample document and sample .dvi file to the
news group.  Contact this user directly for a copy.

------------------------------

From: -XI- Where can I get these packages?
Subject: -M- Tcl References for various platforms

o Duane Murphy <URL: mailto:[email-masked]>
provided a way for Macintosh users to access the information regarding
Tcl built-in commands via a tool known as ZigRef.  It can be found at
<URL: ftp://hitchhiker.space.lockheed.com/pub/TCL/TclBuiltInRef.sea.hqx>.
This version corresponds to Tcl 7.3.

o A commercial tutorial available online can be found at
<URL: http://www.skillshare.com/skillshare/dr/tcl/mod1.html>.  Note
that this is a commercial project - see the page for details of cost.

o A PostScript version of the tcl7.6p2/tk4.2p2 manual pages (with page
numbers, generated Table of Contents as well as index) have been
uploaded to neosoft.  You will find the following files in
<URL: http://www.neosoft.com/tcl/ftparchive/sorted/info/man/>.

tcl7.6p2-tk4.2p2-man-2ps.README    # README for the double sided PS file.
tcl7.6p2-tk4.2p2-man-2ps.tar.gz    # The double sided PostScript files.
  README    # The same as the README above.
  tcl.ps    # The user's manual pages (388 pages/194 sheets of paper)
  tcl-c.ps  # The C interface manual pages (342 pages/171 sheets of paper)

tcl7.6p2-tk4.2p2-man-1ps.README    # README for the single sided PS file.
tcl7.6p2-tk4.2p2-man-1ps.tar.gz    # The single sided PostScript files.
  README    # The same as the README above.
  tcl.ps    # The user's manual pages (299 pages/sheets of paper)
  tcl-c.ps  # The C interface manual pages (251 pages/sheets of paper)

tcl-tk8.0p2-man-1ps.tar.gz and tcl-tk8.0p2-man-2ps.tar.gz are also
available - containing the Tcl/Tk 8.0p2 versions of the man pages for
1 and 2 sided PostScript output.

Some things to note are the following:

1. The PostScript files can be printed on either a LETTER or A4 size
   printer.

2. Manual pages that have multiple links are only printed the first
   time they are found. The rest of the links have a table of contents
   entry that points to the first one.

3. Most linked manual pages are for multiple commands. In the table of
   contents the current name is followed by the other name(s)
   parenthesized and at a reduced point size.

4. The index is built using the commands name and the items in the
   KEYWORDS section of the manual page. The page number in the index
   is the first page of the referenced manual page. Commands and the
   page they are defined on are shown in bold.

See the individual README files for more specific information.

These were provided by Cary D. Renzema <URL: mailto:[email-masked]>.
<URL: ftp://ftp.neosoft.com/languages/tcl/info/man/tcl7.6p2-tk4.2p2-man-html.tar.gz>
covers the HTML version of these files.

------------------------------

From: -XI- Where can I get these packages?
Subject: -N- The "How do I speed up a Tcl/Tk application" doc

<URL: ftp://ftp.neosoft.com/languages/tcl/sorted/packages-7.6/info/doc/speedup.doc.gz>

is a text document with examples on how to speed up Tcl 6.x/Tk 3.x application
performance.

Thanks to Stephen O. Lidie <URL: mailto:[email-masked]> for the work!

Another document on this subject can be found at
<URL: http://ptolemy.eecs.berkeley.edu/tycho/tycho0.2/tycho0.2/doc/coding/performance.html>.

------------------------------

From: -XI- Where can I get these packages?
Subject: -O- http files without a WWW client

The following information has been gathered from a variety of sources.

Within the various TCL FAQs there are references to items in the
form of http://www.w3.org/hypertext/WWW/MarkUp/html-spec/html-spec.txt .
These are in a form which are useful to WorldWideWeb (WWW) clients.
But for those unable to use WWW for some reason, there is a modicum
of relief.  To access these files via email:

1. Address a message to: <URL: mailto:[email-masked]>

2. There is no need for a Subject: line.

3. In the body of the message, type:
GO http://www.w3.org/hypertext/WWW/MarkUp/html-spec/html-spec.txt

4. Any URL can be substituted for the sample above.
Eventually you should get back the file in question.

5. The only restriction is this serves text (HTML and plain) by HTTP
only, no graphics, and no FTP.

For more information about accessing internet files via e-mail, pick up
a copy of the following document:

"INTERNET BY-EMAIL"
Summary: This guide will show you how to retrieve files from FTP sites,
explore the Internet via Gopher, search for information with Archie,
Veronica, or WAIS, tap into the World-Wide Web (WWW), and even access Usenet
newsgroups using E-MAIL AS YOUR ONLY TOOL.

This document is now available from several automated mail servers. To
get the latest edition, send e-mail to one of the addresses below.
To: <URL: mailto:[email-masked]> (for US/Canada/etc.)
Leave Subject blank, and enter only this line in the body of the note:
GET INTERNET BY-EMAIL NETTRAIN F=MAIL

To: <URL: mailto:[email-masked]> (for Eastern US)
Leave Subject blank, and enter only this line in the body of the note:
send usenet/news.answers/internet-services/access-via-email

To: <URL: mailto:[email-masked]> (for UK/Europe/etc.)
Leave Subject blank, and enter only this line in the body of the note:
send lis-iis e-access-inet.txt

You can also get the file at
<URL: ftp://ubvm.cc.buffalo.edu/NETTRAIN/INTERNET.BY-EMAIL>,
<URL: ftp://rtfm.mit.edu/pub/usenet/news.answers/internet-services/access-via-email>,
<URL: ftp://ftp.mailbase.ac.uk/pub/lists/lis-iis/files/e-access-inet.txt>

Note this file is available in over 30 languages.  For the list of translations,
send email to <URL: mailto:[email-masked]> with
Subject: send list
as the subject of the message.

Sometimes, folk ask how to post to usenet via email.  Here's what
I have seen mentioned:

To post, use an e-mail->Usenet gateway.  Send an a e-mail messages to
{newsgroup}@{servername}.  For example, to post to comp.lang.tcl through
nic.funet.fi, address your mail to <URL: mailto:[email-masked]>.

Here are a few e-mail->Usenet gateways that have been reported.  A recent
email indicates that none of these may be operational any longer.

        [email-masked]
        [email-masked]
        [email-masked]
        [email-masked]
        [email-masked]

------------------------------

From: -XI- Where can I get these packages?
Subject: -P- The patch and gzip commands, along with other useful utilities

The patch command is used to apply updates to a source package.  It
assumes that you have the previous version of the source package in
an uncompressed format as well as a file containing one or more modifications
that need to be applied to the original code.

The GNU project's version of the patch command is the one most commonly
used on USENET.  The primary archive for this project is
<URL: ftp://prep.ai.mit.edu/pub/gnu/>.  You will find the source code
located at this FTP site.  Source code for the gzip package, a very
common compression format used on Unix (files compressed with gzip
typically end in either .gz or .tgz), can be found at this site as
well.  For binary versions of either of these programs, you will have
to search what ever the appropriate archive sites are for your
machine.

First, get a version of patch and compile and install it.  Then you
might follow a scenario such as this:

The tcl7.4/README says "apply them to the source directory"!

$ mkdir /usr3/tcl74	# Pick this directory as appropriate
$ cd /usr3/tcl74
$ mv $HOME/tcl7.4.tar.gz /usr3/tcl74/.
$ mv $HOME/tcl7.4p1.patch.gz $HOME/tcl7.4p2.patch.gz /usr3/tcl74/.
$ mv $HOME/tcl7.4p3.patch.gz /usr3/tcl74/.
$ gzip -d < $PWD/tcl7.4.tar.gz | tar xvf -
$ cd tcl7.4
$ gzip -d < ../tcl7.4p1.patch.gz | patch -p1
$ gzip -d < ../tcl7.4p2.patch.gz | patch -p1
$ gzip -d < ../tcl7.4p3.patch.gz | patch -p1
$ $PWD/configure --prefix=/usr3/tcl74
$ make
$ make test
$ make install

assuming your *.gz files all reside in your $HOME directory initially.
This ends up creating a /usr3/tcl74/bin, include, and lib directory.
The binary program tclsh goes into /usr3/tcl74/bin .

If you already have gunzip-ed the files in a different directory (such
as /usr3/tcl74/patch/), you could use them like this:

$ cd /usr3/tcl74/tcl7.4
$ patch -p < ../patch/tcl7.4p1.patch

You will get messages from patch ("hmm, this looks like" and "hunk #n
succeeded") which will scroll off your screen quite fast.  One user has
suggested that if you are using Unix, you can use the script command to
keep all of the output in a log file which you can then peruse later.

You should not get rejected, failed, or wrong version messages.  If you
get those types of messages, you may have missed a patch that needed to be
made, or may be attempting to patch a version of the files not intended to be
patched, or may be in an incorrect directory, or using a bad version of
patch.

If the patch is being applied later, you will want to execute a "make
clean" before the make without arguments, to be sure that you have
gotten rid of any files which need to be recreated during the install
process.

You need to be careful as well trying to perform make on different
machines - if you have to switch computers between makes, you should
execute a "make distclean" followed by another configure command.
This ensures that the various assumptions made by the configuration
program are accurate.  Another alternative would be to create different
subdirectories for each hardware/software platform on which you build
the tcl binaries.

Also, be aware that most patches to date have been built expecting
patch version 2.1.  Patch version 2.2 thru 2.3 at least, and perhaps
version 2.4, have had incompatibilities that may fail in peculiar ways.
Also note that at least Solaris 2.5.1 comes with a patch command quite a bit
older than 2.1, and it too is incompatibile with most patch files, causing
many different kinds of failures.

Another command to which <URL: news:comp.lang.tcl> users sometimes are
referred is a command history filter.  These are programs which sit between
the user's shell and a program and attempt to provide a history mechanism
to commands which have no such capability.  The most frequently mentioned
of these programs is "ile".   The master site for the newest version of
ile is <URL: ftp://ftp.inria.fr/system/user/lile-2.0.tar.z>.
Another commonly referred command history program is "fep".  The master ftp
site for the source code for it is <URL: ftp://ftp.sra.co.jp/pub/cmd/fep.tar.gz>.
A useful place to begin looking for source code for these and other
programs is <URL: ftp://ftp.freebsd.org/> and its mirrors.  A WWW site for
this would be <URL: http://www.freebsd.org/>.

Windows users have begun asking how to format and display the man pages
which come with Tcl, Tk and other applications.  One recently recommended
tool was CAWF.  Cawf v1.0 is a C version of the nroff-like
"Amazingly Workable (text) Formatter. Source & executables are available
at various DOS software archives such as <URL: http://www.execnet.com/>.
With cawf, it seems likely you could format the raw nroff into text.

Another alternative might be <URL: http://web.dcs.bbk.ac.uk/%7Emick/html/>
which is a Perl script which formats raw roff codes into formatted output.

<URL: http://www.parallax.co.uk/%7Erolf/download/manServer.html>
is another of this genre - perl scripts which convert man pages to
html without using nroff.

<URL: http://www-rn.informatik.uni-bremen.de/software/unroff/> is a Scheme
package which translates *roff documents into HTML.

Then, you could go to <URL: http://www.oac.uci.edu/indiv/ehood/> and
pick up the man2html, which will take the formatted files produced
and generate HTML.  Or you could get RosettaMan , which is a part of
the TkMan suite.

In the tknt package (which was a port of Tcl/Tk/Tcl-DP/BLT/itcl to
Windows NT, there was included a man2hlp.zip file containing the
free source for a utility which converted the Tcl man pages into WinHelp
pages.  There are of course commercial packages that folk will be willing
to sell you for this purpose as well.

The package
<URL: ftp://ftp.simtel.net/pub/simtelnet/gnu/djgpp/v2gnu/gro110b.zip> has
a README which begins:
        This is a port of GNU Groff version 1.10 to
        DJGPP v2.01 or later.

It appears to work even under MSDOS, not just Win*.

Another user suggestions locating a package called DOS/DPMI from a simtel
mirror site to find Windows versions of man.exe and groff.

Another useful utility, this time for the Macintosh folk, is suntar, which can
extract files from a tar file.

I have seen notes indicating that Tcl and Tk can be compiled using the
gcc free compiler in unix as well as Win32 (EGCS, FSF, cygwin32, mingw32)
environments.  Also, Win32's lcc should work.  See
<URL: http://www.xraylith.wisc.edu/%7Ekhan/software/gnu-win32/>
<URL: http://www.xraylith.wisc.edu/%7Ekhan/software/tcl/>
<URL: http://www.cygnus.com/misc/gnu-win32/>
<URL: http://sourceware.cygnus.com/cygwin/>
<URL: http://www.cs.virginia.edu/%7Elcc-win32>

In gnu-win32 directon cygnus, fetch either usertools.exe for the user level
Unix-like tools, or cde.exe for the complete C development environment.
At the sourceware web site, pick the full.exe file to install a full
development environment.

Many users mention using the bash shell or other similar shells on their
Windows machines, so that they can get a mechanism similar to #! on Unix
for launching their scripts.

Some users ask about additional sources of icons to use.  One person suggests
<URL: http://www.ibm.com/IBM/hci/resources/icons/icons.html>.

Emacs can convert Tcl code into HTML using the M-x htmlize-buffer command
on an Emacs buffer full of Tcl.  This requires Hrvoje Niksic's htmlize.el
package.  Contact Emil Astrom <URL: mailto:[email-masked]> if you need help
locating the package.

At least one user has recommended "Noweb" as a program for building
documentation into your Tcl application.  See
<URL: http://www.cs.virginia.edu/%7Enr/noweb/intro.html> for more
details.

If you visit <URL: http://www.cs.wisc.edu/%7Eghost/>, you will find
pointers to source and binary distributions (Linux, Windows, MacOS,
other) of PostScript viewing software, useful for viewing a variety of
PostScript versions of man pages, Scriptics' reference manuals, etc.
If you visit <URL: http://www.adobe.com/> you can find a number of binary
versions of acroread, which is a PDF viewer useful for some of the other
reference documents.

------------------------------

From: -XI- Where can I get these packages?
Subject: -Q- Source code from published books

The source code from Brent Welch's book can be found at
<URL: ftp://ftp.prenhall.com/pub/software/welch/tkbook.tar>.

The source code from John Ousterhout's book can be found at
<URL: ftp://ftp.scriptics.com/pub/tcl/doc/book.examples.Z>.

The source code from Don Libes' book can be found with the
expect source code itse"lf.  (See "part04") for
more details.

The source code from Harrison and McLennan's Effective Tcl: Writing
Better Programs in Tcl and Tk book can be found at
<URL: http://www.awl.com/cseng/titles/0-201-63474-0/efftcl-ex.tar.Z>.

The source code from Harrison's Tcl/Tk Tools can be found at
<URL: ftp://ftp.oreilly.com/pub/examples/power_tools/tclt/>.

The examples from D. Tveter's "Pattern Recognition Basis of Artificial
Intelligence"
was recently moved to <URL: http://www.dontveter.com/nnsoft/bp.tar.gz>.

The examples from Doyle and Schroeder's Interactive Web Applications
with Tcl/Tk can be found at <URL: http://www.eolas.com/tcl/>.

------------------------------

From: -XI- Where can I get these packages?
Subject: -R- Documentation relating to Perl's Tk interface

A PostScript format overview of Perl's Tk interface is available from
<URL: ftp://mox.perl.com/pub/perl/ext/TK/tk-userguide.ps.gz>.

A remedial course in perl/Tk, based on the mini-scripts distributed in
the UserGuide.pod file, can be found at
<URL: http://w4.lns.cornell.edu/%7Epvhp/ptk/pod/>.

The perl/Tk <URL: news:comp.lang.perl.tk> proto-FAQ can be found at
<URL: http://www.perl.com/ptk/ptkFAQ.html>
Both of these are maintained by <URL: mailto:[email-masked]>
Peter Prymmer.

John Stoffel <URL: mailto:[email-masked]> wrote some thoughts comparing
Malcom Beatties tcl/tk perl extension and pTk (perl/Tk).  This can be found
at <URL: http://pubweb.bnl.gov/%7Eptk/> along with the rest of the mailing
list comments, code samples, help, etc.

<URL: mailto:[email-masked]> has written up information about pTk
(Perl/Tk) in a book or reference manual format.  It is available at
<URL: http://www.crusoe.net/%7Ejeffp/PERL/>.

Stephen O. Lidie <URL: mailto:[email-masked]> has obtained
permission to republish the very first Perl/Tk article to appear in
The Perl Journal <URL: http://tpj.com/>.  You can find "Perl and the Tk
Extension", aimed towards the Perl/Tk beginner, at
<URL: http://www.Lehigh.EDU/sol0/ptk/tpj1.html>.  All sample source code can
be found at <URL: http://tpj.com/> by selecting the Programs link on this
page.

A Perl/Tk reference card can be found at
<URL: http://www.cpan.org/authors/id/LUSOL/>.  It covers pTk 800.005 .

Olivier Bouteille <[email-masked]> has offered to make
available texinfo formatted documentation for Tk 800.011.  Email
him for details.

Texinfo files for Tcl/Tk have been created by <URL: mailto:[email-masked]>
and can be found at <URL: http://members.tripod.com/gchen2/tcl-info/>.>.>.>.

------------------------------

From: -XI- Where can I get these packages?
Subject: -S- Tutorials on various subjects

Warning: Several of the following sites, unfortunate, do not seem to be
kept up to date with regards to ftp site URLs, reflecting code from the
current versions of Tcl, etc.

There are often questions concerning X security, in particular
relating to Tk's default requirment to refuse to perform send
actions when the user is using xhost rather than xauth for
his/her security.  See <URL: http://ciac.llnl.gov/ciac/documents/ciac2316.html>
for a tutorial on X security.  Also see
<URL: http://www.ice.ru/%7Evitus/works/x11.html>

Another good document on Xauth is available at
<URL: ftp://ph-meter.beckman.uiuc.edu/security/xsecurity.ps>
or
<URL: ftp://ph-meter.beckman.uiuc.edu/security/xsecurity.txt>.

Vivek Khera <URL: mailto:[email-masked]> has written a primer on
setting up your environment for xauth (by default a requirement under
Tk 3.3) in the document <URL: ftp://ftp.neosoft.com/languages/tcl/sorted/packages-7.6/misc/Xauthority.gz>.

Kevin Kenny <URL: mailto:[email-masked]> has also written a document
on how to resolve the xauth situation.
<URL: http://ce-toolkit.crd.ge.com/tkxauth/>

Nat Pryce <URL: mailto:[email-masked]> has begun a project to collect
Tcl programming idioms or patterns.
See <URL: http://www-dse.doc.ic.ac.uk/%7Enp2/patterns/tcl/> for
the root of this document.
See <URL: http://www-dse.doc.ic.ac.uk/%7Enp2/patterns/scripting/tcl/>
is another document he has on a similar topic.
Nat has also written instructions on better integrating Tcl/Tk scripts
with the Windows NT shell.  See
<URL: http://outoften.doc.ic.ac.uk/%7Enp2/software/tcl-setup.html> for the
details.

Frank Pilhofer <URL: mailto:[email-masked]> has written
an article on getting dynamic extensions written in C++ to work.  It
can be found at
<URL: http://www.informatik.uni-frankfurt.de/%7Efp/Tcl/tcl-c++/> in
various formats.  The text only covers Unix issues.

Cameron Laird <URL: mailto:[email-masked]> has written a
number of extremely useful Web pages full of tips for Tcl programmers.
Start at <URL: http://starbase.neosoft.com/%7Eclaird/comp.lang.tcl/> and
look through the pages there.  For instance, at
<URL: http://starbase.neosoft.com/%7Eclaird/comp.lang.tcl/tcl_compilers.html>
you will find an article discussing Tcl compilers.  At
<URL: http://starbase.neosoft.com/%7Eclaird/comp.lang.tcl/tcl-examples.html>
you will find various examples of Tcl coding examples.  The
<URL: http://starbase.neosoft.com/%7Eclaird/comp.lang.tcl/HowToC.html>
page provides pointers and info on "how to use C with Tcl".  There are many
other useful pages for Tcl programmers found here.
Also, take a look at
<URL: http://starbase.neosoft.com/%7Eclaird/comp.software-eng/remediation.html>
which covers the considerations that should be taken when modularizing one's
code.
At
<URL: http://starbase.neosoft.com/%7Eclaird/comp.unix.programmer/linking-unix.html>
you will find discussions relating to the various problems relating to
linking programs under the various Unix platforms.
Cameron has begun
<URL: http://starbase.neosoft.com/%7Eclaird/comp.lang.tcl/tcl_tutorials.html>
which covers his personal notes on online tcl tutorials and
that he recommends.

A brief introductory tutorial to Tcl/Tk can be found at
<URL: http://http2.brunel.ac.uk:8080/%7Ecsstddm/TCL2/TCL2.html>.  Another
one is available at
<URL: http://www.pconline.com/%7Eerc/tcl.htm>.

Yet another tutorial is a software package that is downloadable.  See
<URL: http://www.msen.com/%7Eclif/TclTutor.html> for the details.
It covers Tcl 7.6, 8.0, 8.1 on Unix, Windows 95/NT and Macintosh.

A tutorial from 1994 is located at
<URL: http://www.decus.org/decus/papers/tcl.html>.
Another tutorial, on Tcl and Tk in 5 easy lessions, can be found at
<URL: http://herzberg.ca.sandia.gov/TclCourse/>.

You can check out the first module to a Tcl/Tk class, which is available
at a price from the author, at
<URL: http://www.skillshare.com/skillshare/dr/tcl/mod1.html>.

An online "cookbook", which is a great resource, can be found at
<URL: http://www.itd.clrc.ac.uk/Publications/Cookbook/>.

A brief tutorial on Tcl, Tk, and Expect can be found at
<URL: ftp://ftp.lgc.com/landmark/users/papers/WMorse/wmorse.tcltk>.
This was written by Will Morse <URL: mailto:[email-masked]>.

A tutorial on Tcl written in French was found at
<URL: http://www.loria.fr/moyens-info/logiciels/tcltk/> at one time
but appears to have moved without a forwarding address.
Another Tcl presentation appeared at
<URL: http://kiwi.emse.fr/JJG/SC/TCL/tcl.html>.
A third appears at
<URL: http://slsun2.epfl.ch/LOGICIELS/TclTk/COURS/TclTk_cours.html>.

Foils from a Tcl/Tk class taught in German by
M.Boltes <URL: mailto:[email-masked]> was found under
<URL: http://www.kfa-juelich.de/zam/newsevents/courses/Folien.html>.
There also appears to be one or more German Tcl related postscript documents at
<URL: http://www.kfa-juelich.de/zam/docs/Folien.html>.

Materials from a course taught at the University of Chicago
can be found at
<URL: http://www.lib.uchicago.edu/keith/tcl-course/tcl-course.html>.

Tom Tromey <URL: mailto:[email-masked]> has provided his
Tcl style guide at
<URL: http://drip.colorado.edu/%7Etromey/tcl-style-guide.html>.

John Ousterhout has written an engineering style guide that describes
the coding, documentation, and testing conventions that will be used
at Sun in the coding of the C code in the Tcl core and has graciously
made it available to other Tcl/Tk developers.  It is located at
<URL: ftp://ftp.scriptics.com/pub/tcl/doc/engManual.tar.Z> and
<URL: http://www.scriptics.com/doc/engManual.ps>.
A second style guide, covering the writing of Tcl scripts, can be found at
<URL: ftp://ftp.scriptics.com/pub/tcl/docs/styleGuide.tar.gz> and
<URL: http://www.scriptics.com/doc/styleGuide.pdf>.

A tutorial titled "User interfaces with Tcl/Tk" can be found at
<URL: http://www.scism.sbu.ac.uk/tkteach/>.  It
was written by Fintan Culwin <URL: mailto:[email-masked]>.

A tutorial covering SCO's Visual Tcl can be found at
<URL: http://www.computronics.be/courses/vtcl/CONTENTS.html>.

A brief tutorial on Tcl can be found at
<URL: http://www.python.org/doc/life-preserver/BriefTclTk.html>.
This is a portion of the Python Tkinter Life preserver documentation
which can be found at <URL: http://www.python.org/doc/life-preserver/>.
The beginnings of an intro to Python/Tkinter can be found at
<URL: http://www.pythonware.com/fredrik/tkdraft/>.

A short manual on Tcl (cira 1994) in Japanese was found at
<URL: http://ai-www.aist-nara.ac.jp/doc/documents/kenji-i/tcl.html>.

Another non-English introduction to Tcl can be found at
<URL: http://www.etsimo.uniovi.es/dptos/epm/pi/gedop/intrtcl.html> and
at <URL: http://www.etsimo.uniovi.es/tcl/tutorial/>.

Mac Cody has the syllabus from a Tcl class he has conducted available online
at <URL: http://www.dfw.net/%7Emcody/syllabus/syllabus.html>.

Jean-Claude Wippler <URL: mailto:[email-masked]> has written a tutorial on
how to use a Tcl extension.  See <URL: http://www.equi4.com/jcw/extuse.html> for
pointers to his work.

A small Expect tutorial is at <URL: http://www.decus.org/decus/papers/tcl.html>.

A guide to some of the criteria in making particular program design decisions
can be found at <URL: ftp://ftp.neosoft.com/languages/tcl/sorted/packages-7.6/info/doc/tclarch.txt>.
Its author is Alexandre Ferrieux
<URL: mailto:[email-masked]>.

A Tcl-Java tutorial can be found at
<URL: http://ptolemy.eecs.berkeley.edu/%7Ejohnr/tutorials/tcljava98/>.
This is the basis of a tutorial presented at the 1998 Tcl conference.

There's a Tcl manual at
<URL: http://udgftp.cencar.udg.mx/tutoriales/tcl/contenido/tcl2.html> but
there was some concern about the accuracy of the info.

There is a brief introduction to Tcl and Tk by the developer .com site at
<URL: http://www.developer.com/reference/library/0672310120/html/ch30.htm>.
This article appears to be related to Red Hat Linux Unleashed. and appears
to have been written by Rick McMullin.

A Linux Tcl-Tk-HOWTO can be found now at
<URL: http://space.tin.it/computer/tlqhr/TclTk-HOWTO.html>
Eventually it will appear at
<URL: http://sunsite.unc.edu/LDP/ldp.html> and
<URL: http://www.linux-howto.com> as well as many Linux mirror sites.
It is a collection of documents describing how to use Tcl and Tk on
a Linux system.

A guide to using namespaces and packages is available at
<URL: http://www.cogent.net/%7Eduquette/tcl/namespaces.html>.
A guide to creating object commands can be found at
<URL: http://www.cogent.net/%7Eduquette/tcl>.

A collection of "how to" guides is available at
<URL: http://www.scriptics.com/resource/doc/howto>.

From the "Tcl/Tk for Programmers" book, find chapters on
Tcl Basic syntax <URL: http://www.Mapfree.com/sbf/tcl/book/select/Html/2.html>,
Regular Expressions <URL: http://www.Mapfree.com/sbf/tcl/book/select/Html/7.html>,
Tk Way of Thinking <URL: http://www.Mapfree.com/sbf/tcl/book/select/Html/11.html>,
Geometry Management <URL: http://www.Mapfree.com/sbf/tcl/book/select/Html/13.html>,
and Browser Plugin <URL: http://www.Mapfree.com/sbf/tcl/book/select/Html/21.html>.

See <URL: http://www.hwaci.com/sw/tcldoc/beta2.tar.gz> for the
second public beta release of the XML sources for the core Tcl/Tk
documentation.  <URL: http://www.hwaci.com/sw/tcldoc/html/> is the web
site which discusses more about the effort.  Also, see
<URL: http://www.hwaci.com/sw/tcldoc/html/> for web based versions of
the Tcl and Tk man pages.

See <URL: http://www.cs.man.ac.uk/%7Efellowsd/tcl/option-tutorial.html >
for a tutorial on the tk option command.

See <URL: http://cscene.oftheinter.net/CS2/CS2-08.html> for an article on
using Tcl as a scripting language for a C application.

See <URL: http://6916.lcs.mit.edu/manuals/tcl/> for _Tcl for Web Nerds_ -
an online book by mailto:[email-masked] to provide basic Tcl information
for someone using Tcl as a web programming language.

------------------------------

From: -XI- Where can I get these packages?
Subject: -T-

------------------------------

End of comp.lang.tcl Frequently Asked Questions (3/5)
*****************************************************